function [threshold_train_roc, threshold_cv_roc, thresholds] = getThresholdROC(train, resultsCM, config)

sorted_cv_roc = sort(resultsCM.cv_roc, 'descend');
num_features = config.num_features;
num_thresholds = config.num_thresholds;
num_folds = config.num_folds;

threshold_cv_roc = zeros(num_thresholds, 1);
threshold_train_roc = zeros(num_thresholds, 1);

thresholds = quantile(resultsCM.cv_roc(resultsCM.cv_roc>=sorted_cv_roc(num_features)), 0:1/num_thresholds:1.0);
thresholds(end)=[];
threshold_train = train;

for j=1:length(thresholds)
    threshold_train.data = train.data(:, resultsCM.cv_roc>=thresholds(j));
    disp(['On threshold ' num2str(j) ' of ' num2str(length(thresholds)) ' (' num2str(size(threshold_train.data, 2)) ' features)']);
    for k=1:num_folds
        if(config.verbose)
            disp(['On fold ' num2str(k) ' of ' num2str(num_folds)]);
        end
        
        [cv_train cv_test] = getFold(threshold_train, num_folds, k);
        resultsAlgo = runAlgorithm(cv_train, cv_test, config);
    
        threshold_cv_roc(j) = threshold_cv_roc(j) + resultsAlgo.test_auc;
        threshold_train_roc(j) = threshold_train_roc(j) + resultsAlgo.train_auc;
    end

    threshold_cv_roc(j) = threshold_cv_roc(j)/num_folds;
    threshold_train_roc(j) = threshold_train_roc(j)/num_folds;
end
